#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "mem.h"

void *real_mem_alloc (size_t size, char *func, char *file, int line)
{
return malloc(size);
}

void real_mem_free (void *ptr, char *func, char *file, int line)
{
	if (ptr)
		free (ptr);
}

void *real_mem_allocz (size_t size, char *func, char *file, int line)
{
	return calloc (size, 1);
}

void *real_mem_realloc (void *ptr, size_t size, char *func, char *file, int line)
{
	return realloc (ptr, size);
}

void *real_mem_reallocz (void *ptr, size_t size, char *func, char *file, int line)
{
	return memset (realloc(ptr, size), '\0', size);
}

char *real_mem_strdup (char *str, char *func, char *file, int line)
{
	char *retval = real_mem_alloc (strlen (str) + 1, func, file, line);
	strcpy (retval, str);
	return retval;
}

char *real_mem_strndup (char *str, size_t len, char *func, char *file, int line)
{
	char *retval;
	
	retval = real_mem_alloc (len + 1, func, file, line);
	strncpy (retval, str, len);
	return retval;
}
