#ifndef MEM_H
#define MEM_H

#define msg_debug(str, a...) fprintf (stderr, "%s: %s: %d: " str "\n", __FUNCTION__, __FILE__, __LINE__ , ## a)
#define msg_error(str, a...) fprintf (stderr, str "\n", ## a)
#define msg_display(str, a...) printf (str "\n", ## a)

#define mem_alloc(size) real_mem_alloc(size, __FUNCTION__, __FILE__, __LINE__)
#define mem_free(ptr) real_mem_free(ptr, __FUNCTION__, __FILE__, __LINE__)
#define mem_allocz(size) real_mem_allocz(size, __FUNCTION__, __FILE__, __LINE__)
#define mem_realloc(ptr,size) real_mem_realloc(ptr, size, __FUNCTION__, __FILE__, __LINE__)
#define mem_reallocz(ptr,size) real_mem_reallocz(ptr, size, __FUNCTION__, __FILE__, __LINE__)

#define mem_strdup(str) real_mem_strdup(str, __FUNCTION__, __FILE__, __LINE__)
#define mem_strndup(str, len) real_mem_strndup(str, len, __FUNCTION__, __FILE__, __LINE__)

void *real_mem_alloc (size_t size, char *func, char *file, int line);
void real_mem_free (void *ptr, char *func, char *file, int line);
void *real_mem_allocz (size_t size, char *func, char *file, int line);
void *real_mem_realloc (void *ptr, size_t size, char *func, char *file, int line);
void *real_mem_reallocz (void *ptr, size_t size, char *func, char *file, int line);

char *real_mem_strdup (char *str, char *func, char *file, int line);
char *real_mem_strndup (char *str, size_t len, char *func, char *file, int line);

#endif /* MEM_H */