#ifndef PAPYRUS_DATA_H
#define PAPYRUS_DATA_H

#define PAPYRUS_DATABASE_NUSER 10

typedef struct papyrus_database_info papyrus_database_info;

typedef int (*papyrus_database_init_cb)(papyrus_database_info *info);
typedef int (*papyrus_database_query_cb)(papyrus_database_info *info, char *query_str, int *id);
typedef char *(*papyrus_database_get_cb)(papyrus_database_info *info, int queryid, char *field);
typedef int (*papyrus_database_set_cb)(papyrus_database_info *info, int queryid, char *field, char *value);
typedef int (*papyrus_database_query_clear_cb)(papyrus_database_info *info, int queryid);
typedef int (*papyrus_database_uninit)(papyrus_database_info *info);

int papyrus_binding_init (papyrus_database_info *info);

struct papyrus_database_info
	{
	char *binding;
	char *args;
	
	void *dlhandle;
	
	papyrus_database_init_cb sym;	
	papyrus_database_uninit uninit;
	
	papyrus_database_query_cb query;
	papyrus_database_query_clear_cb clear;
	
	papyrus_database_get_cb get;
	papyrus_database_set_cb set;
		
	void *user_data[PAPYRUS_DATABASE_NUSER];
	};

#endif /* PAPYRUS_DATA_H */