#include <stdio.h>
#include <stdlib.h>

#include <glib.h>
#include <gnome.h>
#include <libgnomeprint/gnome-print.h>
#include <libgnomeprint/gnome-printer-dialog.h>
#include <libgnomeprint/gnome-print-master-preview.h>

#include "mem.h"
#include "print.h"

static GnomePrintMaster *gpm = NULL;
static GnomePrinter *printer = NULL;
static GnomePrintContext *context = NULL;
static char *papername = NULL;
static int is_preview;

char *print_paper (void)
{
	return papername;
}

GnomePrintMaster *print_get_master (void)
	{
	return gpm;
	}

GnomePrinter *print_get_printer (void)
	{
	return printer;
	}
	
GnomePrintContext *print_get_context (void)
	{
	return context;
	}
	
void print_start_file (char *filename, char *paper)
   {
	if (context)
		{
		msg_error ("Printing has already been started");
		return;
		}
	
   papername = paper;

   printer = gnome_printer_new_generic_ps (filename);
   context = gnome_print_context_new_with_paper_size (printer, papername);
   }

void print_start_preview (char *paper)
   {
	if (context)
		{
		msg_error ("Printing has already been started");
		return;
		}
   
	papername = paper;

   is_preview = 1;
  
   gpm = gnome_print_master_new ();
  	gnome_print_master_set_paper (gpm, gnome_paper_with_name (papername));

   context = gnome_print_master_get_context (gpm);
   }

void print_start_printer (char *paper)
   {
	if (context)
		{
		msg_error ("Printing has already been started");
		return;
		}

   papername = paper;

   printer = gnome_printer_dialog_new_modal ();
   context = gnome_print_context_new_with_paper_size (printer, papername);
   }
	
int print_init (char *paper, char *mode)
	{
	char *arg="";
	
	gnome_init ("a-reporting", "0.0.1", 1, &arg);
	
	if (strcasecmp (mode, "preview") == 0)
		print_start_preview (paper);
	else if (strncasecmp (mode, "file", 4) == 0) /* file:/c/waah.ps */
	   {		
		char *filename = &mode[5];
		
		if (strlen (mode) < 6)
			{
			msg_error ("Invalid printer mode: %s, file name not specified", mode);
			return -1;
			}
			
		print_start_file (filename, paper);
		}
	else if (strcasecmp (mode, "printer") == 0)
		print_start_printer (paper);
	
	return 0;
	}
