#ifndef XML_LAYOUT_H
#define XML_LAYOUT_H

#include <libgnomeprint/gnome-print.h>
#include <glib.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

typedef struct layout_item layout_item;

#include "layout_render.h"

typedef enum
	{
	LAYOUT_spacer,
	LAYOUT_integer,
	LAYOUT_string,
	LAYOUT_paragraph,
	LAYOUT_date,
	LAYOUT_image,
	LAYOUT_currency,
	LAYOUT_line,
	LAYOUT_box,
	LAYOUT_group
	} layout_item_type;

typedef enum
	{
	REPORT_group,
	REPORT_pageheader,
	REPORT_pagefooter
	} report_item_type;
	
typedef enum
	{
	LAYOUT_free,
	LAYOUT_left,
	LAYOUT_right,
	LAYOUT_above,
	LAYOUT_below
	} layout_position;
	
typedef struct
	{
	double red;
	double green;
	double blue;
	double alpha;
	} layout_colour;
	
struct layout_item
	{
	xmlNode *node;
	xmlNode *group;
	
	char *name;	
	char *data;
	layout_item_type type;
			
	GnomeFont *font;
	double font_size;

	layout_item *parent;
	GList *children;
	layout_colour *colour;
	layout_colour *bgcolour;
	layout_position pos;
	
	int x;
	int y;
	int width;
	int height;
	};

typedef struct
	{
	report_item_type type;
	layout_item *header;
	layout_item *body;
	layout_item *footer;
	} report_item;
	
GList *xml_build_file (xmlDoc *doc);
	
#endif 